import org.xmldb.api.DatabaseManager;
import org.xmldb.api.base.Collection;
import org.xmldb.api.base.Database;
import org.xmldb.api.base.XMLDBException;
import org.xmldb.api.modules.CollectionManagementService;


abstract class XMLDB  {

  String   driver, dbUri;
  Database db;

  // XMLDBI[v(hCow)
  public void open( String driver )
    throws XMLDBException,
      ClassNotFoundException, IllegalAccessException, InstantiationException {
    db = (Database)Class.forName( driver ).newInstance();
    DatabaseManager.registerDatabase( db );
  }

  // XMLDBI[v(RXgN^ݒhCogp)
  public void open()
    throws XMLDBException,
      ClassNotFoundException, IllegalAccessException, InstantiationException {
    open( driver );
  }

  // XMLDBN[Y
  public void close() throws XMLDBException  {
    DatabaseManager.deregisterDatabase( db );
  }

  // XMLDBURIw肵ăRNV擾(URIw)
  public Collection getCollection( String dbUri ) throws XMLDBException  {
    return DatabaseManager.getCollection( dbUri );
  }

  // XMLDBURIw肵ăRNV擾(RXgN^ݒURIgp)
  public Collection getCollection() throws XMLDBException  {
    return getCollection( dbUri );
  }

  // RNV̒ǉ폜s߂ɕKv
  // CollectionManagementService̎NX̃CX^X擾
  abstract
      public CollectionManagementService getCollectionManagementServiceImpl();

  // RNV̒ǉ폜sCollectionManagementService擾
  public CollectionManagementService getCollectionManagementService()
                                                      throws XMLDBException  {
    return getCollectionManagementServiceImpl();
  }

  // RNV̒ǉ폜sCollectionManagementService擾
  // (_ƂȂRNVɎw)
  public CollectionManagementService
                      getCollectionManagementService( Collection col )
                                                      throws XMLDBException  {
    CollectionManagementService cms = getCollectionManagementService();
    cms.setCollection( col );
    return cms;
  }

  public void setDriver( String driver )  {  this.driver = driver;  }
  public void setUri( String dbUri )      {  this.dbUri  = dbUri;   }

  public XMLDB( String driver, String dbUri )  {
    setDriver( driver );
    setUri( dbUri );
  }

  public XMLDB( String driver )  {
    this( driver, null );
  }

  public XMLDB()  {
    driver = null;
    dbUri  = null;
  }

}