import java.io.IOException;
import java.io.StringWriter;
import java.io.Writer;
import java.util.StringTokenizer;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Node;

import org.xmldb.api.base.Collection;
import org.xmldb.api.modules.XMLResource;


// URLθˤĤ줿'/transformer/(XSLTID)/(XMLID)'Xindice
// 쥯󤫤XML,XSLTTransformer饹ȤäHTMLѴ
public class XindiceTransformerServlet extends HttpServlet  {

  XMLDB      xmldb;
  Collection rootCol, xmlCol, xsltCol;

  TransformerFactory tf;

  public void init() throws ServletException  {

    // TransformerFactoryΥ󥹥󥹤
    tf = TransformerFactory.newInstance();

    try  {
      // Xindice򥪡ץ󤹤
      System.setProperty( "xindice.home",
                    getServletConfig().getInitParameter( "xindice.home" ) );
      xmldb = new Xindice(
                    getServletConfig().getInitParameter( "collection.root" ) );
      xmldb.open();

      // 롼ȤȤʤ륳쥯
      rootCol = xmldb.getCollection();
      // XMLɥȤΥ쥯
      xmlCol  = rootCol.getChildCollection(
                    getServletConfig().getInitParameter( "collection.xml" ) );
      // XSLTɥȤΥ쥯
      xsltCol = rootCol.getChildCollection(
                    getServletConfig().getInitParameter( "collection.xslt" ) );
    } catch( Exception ex ) {
      throw new ServletException( ex.getMessage() );
    }

  }

  // ֥åȤ˥뤿Ӥ˵ư᥽å
  public void doGet( HttpServletRequest req, HttpServletResponse res )
                                      throws IOException, ServletException  {

    // XML,XSLTΥɥIDꤹ
    StringTokenizer st = new StringTokenizer( req.getPathInfo(), "/" );
    String      xsltId = st.nextToken();    // XSLTΥɥID
    String       xmlId = st.nextToken();    // XMLΥɥID

    // HTMLؤѴ̤öStringWriter˽Ϥ
    StringWriter result = new StringWriter();

    try {

      // TransformerѤXML,XSLTNodeXindiceФ
      Node  xmlNode =
            ((XMLResource)xmlCol.getResource( xmlId )).getContentAsDOM();
      Node xsltNode =
            ((XMLResource)xsltCol.getResource( xsltId )).getContentAsDOM();

      // TransformerѤXML,XSLTNodeꤹ
      // XML, XSLTȤXindiceΥ쥯󤫤뤿DOMSource
      DOMSource  xmlIn = new DOMSource( xmlNode );
      DOMSource xsltIn = new DOMSource( xsltNode );

      // TransformerˤѴ̤νStringWriterꤹ
      StreamResult htmlOut = new StreamResult( result );

      // XSLTɤ߹TransformerΥ󥹥󥹤
      Transformer t = tf.newTransformer( xsltIn );

      // Ѵ̤νˡHTMLȤ
      t.setOutputProperty( "method", "html" );
      // UTF-8ǽϤϥѥ᡼encodingλάǽ
      t.setOutputProperty( "encoding", "Shift_JIS" );
      // XMLɤ߹HTMLѴ
      t.transform( xmlIn, htmlOut );

    } catch( Exception ex ) {
      throw new ServletException( ex.getMessage() );
    }

    // 餫ǡHTMLȤ
    res.setContentType( "text/html;charset=Shift_JIS" );
    // UTF-8ϰʲΤ褦˻ꤹ
    // res.setContentType( "text/html;charset=UTF-8" );
    // Web֥饦ؤHTML
    Writer out = res.getWriter();
    // Ѵ(HTML)
    out.write( result.toString() );
    out.flush();

    out.close();

  }

  public void destroy()  {
    try  {
      xmlCol.close();
      xsltCol.close();
      rootCol.close();
      xmldb.close();
    } catch( Exception ex ) {}
  }

}